#table base block support
execute as @e[tag=holo.entity.table_base_marker] at @s if block ~ ~ ~ barrier run clone ~ 319 ~ ~ 319 ~ ~ ~ ~
execute as @e[tag=holo.entity.table_base_marker] at @s unless block ~ ~ ~ air run setblock ~ 319 ~ air
kill @e[tag=holo.entity.table_base_marker]

#general nessecaries
tag @e[tag=gui_table] remove gui_table

execute as @a[nbt={SelectedItem:{id:"minecraft:nether_star",tag:{holo_item:1b}}},tag=!holo.p.place.platform,tag=!spawn_table1_try,tag=!spawn_table2_try,tag=!spawn_table3_try] at @s run tag @e[tag=holo_table,tag=!holo_locked,sort=nearest,limit=1,distance=..4] add gui_table

#clears holo_items out of the player inventory
execute as @a store success score @s holo.p.click run clear @s #holo:gui_items{gui_item:1b}
execute at @e[type=minecraft:item,nbt={Item:{tag:{gui_item:1b}}}] as @p store success score @s holo.p.click run kill @e[type=minecraft:item,nbt={Item:{tag:{gui_item:1b}}},limit=1,sort=nearest]

#summon table_temp
execute as @e[tag=gui_table,tag=!has_table_temp] at @s run function holo:gui_table/summon_table_temp

#delete table_temp
execute as @e[tag=table_temp] at @s unless entity @e[tag=gui_table,tag=has_table_temp,distance=..2] run kill @s
execute as @e[tag=holo_table,tag=!gui_table,tag=has_table_temp] at @s run function holo:gui_table/remove_gui

#move table temp
execute as @e[tag=table_temp] at @s if block ~ ~-1 ~ minecraft:barrel[open=true] run tag @s add in_barrel
execute as @e[tag=table_temp] at @s if block ~ ~-1 ~ minecraft:barrel[open=false] run tag @s remove in_barrel
execute as @e[tag=gui_table,tag=has_table_temp] at @s as @e[tag=table_temp,tag=!in_barrel,distance=..2] if score @s holo_data = @e[tag=gui_table,tag=has_table_temp,distance=..0.01,limit=1] holo_data run function holo:gui_table/move_table_temp

#switch block run
execute as @e[tag=gui_table,tag=holo_switch] at @s at @e[tag=table_temp,distance=..2,limit=1] unless entity @e[type=falling_block,distance=..2,tag=holo_switch] run function holo:gui_table/switch_run

#main (updates gui)
execute as @e[tag=table_temp] at @s as @e[tag=gui_table,tag=has_table_temp,distance=..2] if score @s holo_data = @e[tag=table_temp,distance=..0.01,limit=1] holo_data run function holo:gui_table/main

kill @e[type=minecraft:item,nbt={Item:{tag:{gui_item:1b}}}]

#info drop gui item -> new table/platform
execute as @a[nbt={SelectedItem:{id:"minecraft:nether_star",tag:{holo_item:1b}}}] unless entity @e[type=block_display,tag=holo_platform] unless entity @e[tag=spawn_table1_click] unless entity @e[tag=spawn_table2_click] unless entity @e[tag=spawn_table3_click] unless entity @e[tag=spawn_platform_click] run title @s actionbar ["",{"text":"Press ["},{"keybind":"key.drop"},{"text":"] to place a Hologram Platform!"}]
execute as @a[nbt={SelectedItem:{id:"minecraft:nether_star",tag:{holo_item:1b}}}] if entity @e[type=block_display,tag=holo_platform] unless entity @e[tag=spawn_table1_click] unless entity @e[tag=spawn_table2_click] unless entity @e[tag=spawn_table3_click] unless entity @e[tag=spawn_platform_click] run title @s actionbar ["",{"text":"Press ["},{"keybind":"key.drop"},{"text":"] to place a Hologram Table!"}]
execute as @e[type=item,nbt={Item:{id:"minecraft:nether_star",tag:{holo_item:1b}}}] at @s run function holo:gui_table/drop

#table lock/unlock mechanics
tag @e[tag=gui_unlock] remove gui_unlock
execute as @a[nbt={SelectedItem:{id:"minecraft:nether_star",tag:{holo_item:1b}}},tag=!holo.p.place.platform,tag=!holo_moving] at @s run tag @e[tag=holo_table,tag=holo_locked,sort=nearest,limit=1,distance=..4] add gui_unlock
execute as @e[tag=gui_unlock,tag=holo_table1] at @s unless entity @e[tag=gui_unlocker,distance=..0.1] run summon interaction ~ ~ ~ {CustomNameVisible:1b,width:1.1f,height:1f,response:1b,Tags:["gui_unlocker"],CustomName:'[{"text":" Right Click to unlock!","color":"dark_green","bold":true}]'}
execute as @e[tag=gui_unlock,tag=holo_table2] at @s unless entity @e[tag=gui_unlocker,distance=..0.1] run summon interaction ~ ~ ~ {CustomNameVisible:1b,width:2.1f,height:1f,response:1b,Tags:["gui_unlocker"],CustomName:'[{"text":" Right Click to unlock!","color":"dark_green","bold":true}]'}
execute as @e[tag=gui_unlock,tag=holo_table3] at @s unless entity @e[tag=gui_unlocker,distance=..0.1] run summon interaction ~ ~ ~ {CustomNameVisible:1b,width:3.1f,height:1f,response:1b,Tags:["gui_unlocker"],CustomName:'[{"text":" Right Click to unlock!","color":"dark_green","bold":true}]'}

execute as @e[tag=gui_unlocker] at @s unless entity @e[tag=gui_unlock,distance=..0.1] run kill @s
execute as @e[type=interaction,tag=gui_unlocker] at @s if data entity @s interaction run tag @e[tag=gui_unlock,distance=..0.1] remove holo_locked

#rotaing hologramm
execute as @e[type=block_display,tag=success_tp,tag=rotating] at @s run tp @s ~ ~ ~ ~3 ~